/*
* File   : $Source: /usr/local/cvs/opencms/src/com/opencms/htmlconverter/CmsHtmlConverterObjectReplaceContent.java,v $
* Date   : $Date: 2001/11/21 10:58:33 $
* Version: $Revision: 1.1 $
*
* This library is part of OpenCms -
* the Open Source Content Mananagement System
*
* Copyright (C) 2001  The OpenCms Group
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* For further information about OpenCms, please see the
* OpenCms Website: http://www.opencms.org
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

package com.opencms.htmlconverter;

/**
 * Object to replace content in html code before
 * parsing it with JTidy.
 * @author Andreas Zahner
 * @version 1.0
 */
class CmsHtmlConverterObjectReplaceContent {

    /** String which will be replaced */
    private String m_searchString;
    /** String which replaces old content */
    private String m_replaceString;

    /**
     * default constructor creates object with empty Strings
     */
    protected CmsHtmlConverterObjectReplaceContent () {
        m_searchString = "";
        m_replaceString = "";
    }

    /**
     * constructor creates object with parameter values
     * @param sS String searchString
     * @param rS String replaceString
     */
    protected CmsHtmlConverterObjectReplaceContent (String sS, String rS) {
        m_searchString = sS;
        m_replaceString = rS;
    }

    /**
     * returns the String to be found
     * @return String to be found
     */
    protected String getSearchString() {
        return m_searchString;
    }

    /**
     * returns the new content
     * @return new content without prefix and suffix
     */
    protected String getReplaceItem() {
        return m_replaceString;
    }

}
